package com.jiuqi.grid;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.grid.CellDataProcessorIntf;
import com.jiuqi.grid.CellDataProperty;
import com.jiuqi.grid.CellDataPropertyIntf;
import com.jiuqi.grid.GridCell;
import com.jiuqi.grid.TextCellPropertyIntf;

public class TextCellProperty implements TextCellPropertyIntf, CellDataProcessorIntf {
  protected CellDataPropertyIntf cellDataProperty;
  
  public TextCellProperty(GridCell cell) {
    this((CellDataPropertyIntf)new CellDataProperty(cell));
  }
  
  public TextCellProperty(CellDataPropertyIntf dataProperty) {
    this.cellDataProperty = dataProperty;
  }
  
  public CellDataPropertyIntf getCellDataProperty() {
    return this.cellDataProperty;
  }
  
  public boolean getMultiLine() {
    return ((this.cellDataProperty.getDataFlag() & 0x1) != 0);
  }
  
  public void setMultiLine(boolean value) {
    if (value) {
      this.cellDataProperty.setDataFlag(
          (byte)(this.cellDataProperty.getDataFlag() | 0x1));
    } else {
      this.cellDataProperty.setDataFlag(
          (byte)(this.cellDataProperty.getDataFlag() & 0xFFFFFFFE));
    } 
  }
  
  public boolean getAllowMultiLine() {
    return ((this.cellDataProperty.getDataFlag() & 0x2) != 0);
  }
  
  public void setAllowMultiLine(boolean value) {
    if (value) {
      this.cellDataProperty.setDataFlag(
          (byte)(this.cellDataProperty.getDataFlag() | 0x2));
    } else {
      this.cellDataProperty.setDataFlag(
          (byte)(this.cellDataProperty.getDataFlag() & 0xFFFFFFFD));
    } 
  }
  
  public int getCharCase() {
    return this.cellDataProperty.getDataFlag() >> 2;
  }
  
  public void setCharCase(int value) {
    if (value >= 0 && value < 3) {
      int data = (value & 0x3) << 2;
      this.cellDataProperty.setDataFlag(
          (byte)(this.cellDataProperty.getDataFlag() & 0xFFFFFFF3 | data));
    } else {
      throw new IllegalArgumentException("错误设置了文本大小写情况,只能在0-2之间！");
    } 
  }
  
  public int getMaxLength() {
    return this.cellDataProperty.getDataProperty();
  }
  
  public void setMaxLength(int value) {
    if (value >= 0) {
      this.cellDataProperty.setDataProPerty((short)value);
    } else {
      throw new IllegalArgumentException("不能设置文本的最大长度为负数！");
    } 
  }
  
  public String getEditText(String storeText) {
    return storeText;
  }
  
  public String getShowText(String storeText) {
    return storeText;
  }
  
  public String parseEditText(String editText) {
    if (editText != null) {
      if (editText == "")
        return ""; 
      String storeText = null;
      int charCase = getCharCase();
      switch (charCase) {
        case 0:
          storeText = editText;
          break;
        case 2:
          storeText = editText.toLowerCase();
          break;
        case 1:
          storeText = editText.toUpperCase();
          break;
        default:
          storeText = editText;
          break;
      } 
      int textLength = storeText.length();
      int maxLength = getMaxLength();
      if (maxLength != 0 && 
        textLength > maxLength)
        storeText = storeText.substring(0, maxLength); 
      return storeText;
    } 
    throw new IllegalArgumentException("不能解析指向null的字符串！");
  }
  
  public String parseShowText(String showText) {
    return parseEditText(showText);
  }
}
